︠fc181d9a-9251-4d36-8e1a-1c1466730c23︠
def sns(a):
    """
    Determines the sns of a sign pattern matrix.
        
    INPUT:
        A square matrix, where each element should only be from the set {-1,0,1}.
        1 signifying a positive sign and -1 signifying a negative sign,
        while 0 will simply signify 0.
    
    OUTPUT:
        Outputs the sns number of the matrix.

    EXAMPLES::
        sage:a = matrix([[1,-1],[-1,1]])
        sage:a

        [ 1 -1]
        [-1  1]
        sage:sns(a)
        1
    """    
    length = a.ncols();
    new_matrix=matrix(length,[var('x%s%s'%(i,j)) for i in range(length) for j in range(length)])
    b = matrix(length,[(new_matrix[i,j] * a[i,j]) for i in range(length) for j in range(length)])
    for i in range(length,0,-1):
        for v in CartesianProduct(Subsets(range(length),i),Subsets(range(length),i)):
            for det in [b[list(v[0]),list(v[1])].det().expand()]:
                w=[[-1 in term.operands() for term in det.operands()]]
                if any([not(True in k and False in k) for k in w]):
                    return i
︡1947845c-ab0a-410c-824e-c8b1e7fa9ee1︡︡
︠8cc25374-18aa-474b-bfce-59c2999b1679︠
# Make a random -1,0,1 matrix
a=random_matrix(ZZ,5,x=-1,y=2)
a
︡10271e68-879c-4443-b6a0-03837dc9baf3︡{"stdout": "[ 0  0  0  0  0]\n[ 0  1  1 -1  0]\n[-1 -1 -1  0 -1]\n[ 1  1 -1 -1  0]\n[-1 -1  0 -1  0]"}︡
︠d09946d6-5c72-4cce-9c34-a8798743b4e3︠
sage_input(a)
︡b722ac9f-f575-4f36-9974-e9e0874bb7df︡{"stdout": "matrix(ZZ, [[0, 0, 0, 0, 0], [0, 1, 1, -1, 0], [-1, -1, -1, 0, -1], [1, 1, -1, -1, 0], [-1, -1, 0, -1, 0]])"}︡
︠20700383-0de4-478c-ae38-5894bd9a8920︠
sns(a)
︡5ac04275-b4ee-40ce-8227-293d5af60383︡{"stdout": "5"}︡
︠f029d3a9-e29b-47a0-ac19-f8f8eda04bfd︠
g=DiGraph(a)
︡3034f1c0-8bd2-4d41-bd4f-1a6cfa8c013c︡︡
︠210df88d-aeea-48f3-a671-643b966131bb︠
g.plot(edge_labels=True, save_pos=True)
︡a80fa602-515e-447f-9dab-f52caa27d38a︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠95d88473-92fe-4bcd-8c7e-8b40470fb766︠
g.plot(color_by_label=True)
︡7dff275c-127f-4018-9660-48ae7508fa66︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠f9ba0360-dcc6-4776-a362-2561c7254f1e︠
g.weighted_adjacency_matrix()
︡0142dba7-1f22-47f6-8549-b3139ae08cfc︡{"stdout": "[ 0  0  0  0  0]\n[ 0  1  1 -1  0]\n[-1 -1 -1  0 -1]\n[ 1  1 -1 -1  0]\n[-1 -1  0 -1  0]"}︡
